package Counter;

/**
* Fixes Nested Monitors.
*/
public class BoundedCounterVCV implements BoundedCounter {
	protected long count_ = MIN; 
	protected Condition notMin_ = new SimpleConditionObject();
	protected Condition notMax_ = new SimpleConditionObject();

	public synchronized long value() { return count_; }

	public void dec() {						// not synched!
		boolean wasMax = false;			// record notification condition
		synchronized(notMin_) {			// synch on condition object
			while (true) {						// new guard loop
				synchronized(this) {
					if (count_ > MIN) {		// check and act
						wasMax = (count_ == MAX);
						count_--;
						break;
					}
				}
				notMin_.await();				// release host synch before wait
			}
		}
		if (wasMax)
			notMax_.signal();					// release all synchs!
	}

	public void inc() {
		boolean wasMin = false;
		synchronized(notMax_) {
			while (true) {
				synchronized(this) {
					if (count_ < MAX) {
						wasMin = (count_ == MIN);
						count_++;
						break;
					}
				}
				notMax_.await();
			}
		}
		if (wasMin)
			notMin_.signal();
	}

}