package ReadWrite;

class ReadWriteDemo extends RWVT {

	static public void main(String[] args) 
	{
		new ReadWriteDemo().doit();
	}

	class Client extends Thread {
		protected final String id_;
		protected final RWVT host_;
		protected final int COUNT = 10;
		Client(String id, RWVT host) { id_ = id; host_ = host; }
		public void run() {
			for (int i=0; i<=COUNT; i++) {
				System.out.println(id_ + " STARTING");
				doit();
				System.out.println(id_ + " DONE");
			}
		}
		protected void doit() { }
	}

	class Reader extends Client {
		Reader(String id, RWVT host) { super(id, host); }
		protected void doit() { host_.read(); }
	}

	class Writer extends Client {
		Writer(String id, RWVT host) { super(id, host); }
		protected void doit() { host_.write(); }
	}	

	public void doit() {
		System.out.println("Starting ReadWriteDemo");
		new Reader("Reader1", this).start();
		new Reader("Reader2", this).start();
		new Writer("Writer1", this).start();
		new Writer("Writer2", this).start();
	}

	protected void read_() {
		System.out.println("-----READING");
		randomSleep();
		System.out.println("-----DONE READING");
	}

	protected void write_() {
		System.out.println("#####WRITING");
		randomSleep();
		System.out.println("#####DONE WRITING");
	}
	
	public void randomSleep() {
		try {
			Thread.sleep((int)(Math.random() * 10));
		} catch (InterruptedException e) { }
	}
	
}
