package Slot;

class FutureDemo {

	public static void demo() {
		FutureDemo server = new FutureDemo();
		System.out.println("Starting FutureDemo.demo()");
		for (int n=15;n>=12;n--) {
			startDemoThread(server, n);
		}
	}

	protected static void startDemoThread
		(final FutureDemo server, final int n) {
		new Thread() {
			public void run() {
				System.out.println("CALLING service("+n+")");
				Future f = server.service(n);
				System.out.println("GOT future("+n+")");
				int val = ((Integer) f.value()).intValue();
				System.out.println("GOT service("+n+") = " + val);
			}
		}.start();
	}

	public Future service (final int n) {		// unsynchronized
		final Slot slot = new Slot();
		new Thread() {
			public void run() {
				slot.put(computeResult(n));
			}
		}.start();
		return new Future(slot);				// immediately return Future
	}

	protected synchronized Object computeResult(int n) {
		return new Integer(fibonacci(n));
	}
	
	/**
	* slow, naive algorithm
	*/
	public static int fibonacci(int n) {
		if (n<2) return 1;
		else return fibonacci(n-1) + fibonacci(n-2);
	}
}
