/*
  File: BoundedBuffer.java
*/

package bufferSol;

import java.awt.*;
import java.applet.*;
import support.*;

public class NestedMonitor extends Applet 
{

	Producer producer_;
	
	Consumer consumer_;

	DisplayBuffer buffer_;

	public void init() 
	{
		super.init();

		// Setup
		buffer_ = new DisplayBuffer( 5 );
		RotatingPanel p = new RotatingPanel( "Producer" );
		p.setRotatorColor( Color.blue );
		RotatingPanel c = new RotatingPanel( "Consumer" );
		c.setRotatorColor( Color.yellow );

		producer_ = new Producer( buffer_, p );
		consumer_ = new Consumer( buffer_, c );

		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.anchor = GridBagConstraints.NORTH;
		gridbag.setConstraints( buffer_.getView(), gc );
		gridbag.setConstraints( p, gc );
		gridbag.setConstraints( c, gc );
		add( p );
		add( buffer_.getView() );
		add( c );
	}

	public void start() 
	{
		producer_.start();
		consumer_.start();
		buffer_.init();
	}


	public void stop() 
	{
		producer_.stop();
		consumer_.stop();
	}

}
